<div id="current-consumption">
  <table
    mat-table
    multiTemplateDataRows
    [dataSource]="currentConsumptionDataSource"
    class="border-grey-600"
    aria-label="Data Spaces current consumptions table"
  >
    @for (col of currentConsumptionCols; track col) {
      <ng-container matColumnDef="{{ col }}">
        @if (col !== "detailView") {
          <th mat-header-cell *matHeaderCellDef class="bg-grey-300">
            <b>
              {{
                col === "cpu"
                  ? (mapProp2Column.get(col) | uppercase)
                  : (mapProp2Column.get(col) | titlecase)
              }}
            </b>
          </th>
        } @else {
          <th mat-header-cell *matHeaderCellDef class="bg-grey-300"></th>
        }
        <td mat-cell *matCellDef="let currentConsumption">
          @if (col === "status") {
            <div class="ec-chips-theme">
              <mat-chip
                highlighted
                class="slabs-chip mx-0"
                [color]="status2ChipColor.get(currentConsumption.status)"
              >
                {{ currentConsumption[col] }}
              </mat-chip>
            </div>
          } @else if (col === "detailView") {
            <button
              class="justify-content-end p-0"
              mat-button
              color="primary"
              (click)="viewDataSpaceDetail(currentConsumption)"
            >
              <mat-icon class="arrow-forward-icon">arrow_forward</mat-icon>
            </button>
          } @else if (col !== "name" && col !== "status") {
            <span>
              {{
                (currentConsumption[col + "Used"]
                  | number
                    : optimiseDecimalDigits(currentConsumption[col + "Used"])) +
                  " / " +
                  (currentConsumption[col + "Allocated"]
                    | number
                      : optimiseDecimalDigits(
                          currentConsumption[col + "Allocated"]
                        )) +
                  " " +
                  (col.toLowerCase().includes("cpu") ? "cores" : "GB")
              }}
              <b>
                {{
                  " (" +
                    (currentConsumption[col + "Used"] /
                      currentConsumption[col + "Allocated"]
                      | percent: "1.0-1") +
                    ")"
                }}
              </b>
            </span>
          } @else {
            {{ currentConsumption[col] }}
          }
        </td>

        <td mat-footer-cell *matFooterCellDef="let currentConsumption">
          @if (col === "name") {
            <span>
              {{
                (currentConsumptionDataSource.connect() | async)!.length > 0
                  ? (currentConsumptionDataSource.connect() | async)!.length +
                    " Data Space" +
                    ((currentConsumptionDataSource.connect() | async)!.length >
                    1
                      ? "s"
                      : "")
                  : ""
              }}
            </span>
          } @else if (col !== "status" && col !== "detailView") {
            <span>
              {{
                (currentConsumptionDataSource.connect() | async)!.length > 0
                  ? ((currentConsumptionDataSource.connect() | async)!
                      | sum: [col + "Used"]
                      | number
                        : optimiseDecimalDigits(
                            (currentConsumptionDataSource.connect() | async)!
                              | sum: [col + "Used"]
                          )) +
                    " / " +
                    ((currentConsumptionDataSource.connect() | async)!
                      | sum: [col + "Allocated"]
                      | number
                        : optimiseDecimalDigits(
                            (currentConsumptionDataSource.connect() | async)!
                              | sum: [col + "Allocated"]
                          ))
                  : "- / -"
              }}
              <b>
                {{
                  (currentConsumptionDataSource.connect() | async)!.length > 0
                    ? " (" +
                      (((currentConsumptionDataSource.connect() | async)!
                        | sum: [col + "Used"]) /
                        ((currentConsumptionDataSource.connect() | async)!
                          | sum: [col + "Allocated"]) | percent: "1.0-1") +
                      ")"
                    : ""
                }}
              </b>
            </span>
          }
        </td>
      </ng-container>

      <ng-container matColumnDef="{{ '_' + col }}">
        <th mat-header-cell *matHeaderCellDef class="bg-grey-300">
          {{
            col !== "name" && col !== "status" && col !== "detailView"
              ? "(used/allocated)"
              : ""
          }}
        </th>
      </ng-container>

      <ng-container matColumnDef="{{ col === 'name' ? 'total' : '__' + col }}">
        <td mat-footer-cell *matFooterCellDef>
          {{ col === "name" ? "Total" : "" }}
        </td>
      </ng-container>
    }

    <tr
      mat-header-row
      *matHeaderRowDef="currentConsumptionCols"
      class="first-header-row"
    ></tr>
    <tr
      mat-header-row
      *matHeaderRowDef="secondHeaderCols"
      class="second-header-row"
    ></tr>
    <tr
      mat-row
      *matRowDef="let currentConsumption; columns: currentConsumptionCols"
    ></tr>

    <tr
      class="first-footer-row bg-eu"
      mat-footer-row
      *matFooterRowDef="firstFooterCols"
    ></tr>
    <tr
      class="second-footer-row bg-eu"
      mat-footer-row
      *matFooterRowDef="currentConsumptionCols"
    ></tr>
  </table>
</div>
